=== debian/changelog ===
pocl (4.0-2) unstable; urgency=medium

  * Rebuild with GCC 13.
  * Update symbols file for amd64 and i386.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Aug 2023 15:53:17 +0200

pocl (4.0-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Fix virtual package pocl-source-$version in case of ~rc versions.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Jun 2023 17:08:19 +0200

pocl (4.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Fix FTBFS on i386.
  * Update symbols file for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 14 Jun 2023 14:31:23 +0200
